﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
 *Goal State:
 *1 2 3
 *8 0 4
 *7 6 5
 *
 * odds can move in two directions
 * evens can move in three
 * 0 can move in four
 */

namespace AI
{
    class Dist
    {
        /// <summary>
        /// This class is the Manhattan Distance implementation
        /// </summary>
        /// <param name="state"></param>
        /// <returns></returns>
        public int Check(int[] state)
        {
            int i = 0;
            int dist = 0;
            foreach (int v in state)
            {
                if(v != 0)
                {
                    if (v != i)
                    {
                        int destX, destY;
                        if (v <= 3)
                        {
                            destY = 1;
                            destX = v;
                        }
                        else if (v <= 7 && v >= 5)
                        {
                            destY = 3;
                            destX = 8 - v;
                        }
                        else
                        {
                            destY = 2;
                            switch (v)
                            {
                                case 8:
                                    destX = 1;
                                    break;
                                case 0:
                                    destX = 2;
                                    break;
                                case 4:
                                    destX = 3;
                                    break;
                                default:
                                    destX = 0;
                                    break;
                            }
                        }

                        int curX, curY;
                        if (i <= 3)
                        {
                            curY = 1;
                            curX = i;
                        }
                        else if (i <= 7 && i >= 5)
                        {
                            curY = 3;
                            curX = 8 - i;
                        }
                        else
                        {
                            curY = 2;
                            switch (i)
                            {
                                case 8:
                                    curX = 1;
                                    break;
                                case 0:
                                    curX = 2;
                                    break;
                                case 4:
                                    curX = 3;
                                    break;
                                default:
                                    curX = 0;
                                    break;
                            }
                        }

                        dist += Math.Max(curY - destY, destY - curY);
                        dist += Math.Max(curX - destX, destX - curX);
                    }
                }

                i++;
            }
            return dist;
        }
    }
}
