﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;

namespace AI
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// This class handles the UI.
        /// It also contains the assignment combinations.
        /// Unless the second set of combinations are uncommented,
        /// attempting to solve assignment combinations will cause a hang and crash,
        /// as two of the combinations appear to be unsolvable.
        /// </summary>

        protected int[] state = {0,1,2,3,4,5,6,7,8};

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void AssSolve()
        {
            /*
             *Goal State:
             *1 2 3
             *8 0 4
             *7 6 5
             */

            
            int[][] c = new int[8][];
            c[0] = new int[] { 2, 8, 6, 3, 1, 4, 7, 0, 5 }; 
            c[1] = new int[] { 5, 8, 6, 3, 1, 2, 7, 0, 4 }; 
            c[2] = new int[] { 8, 7, 6, 3, 2, 5, 1, 4, 0 }; 
            c[3] = new int[] { 4, 6, 0, 3, 1, 2, 5, 7, 8 }; 
            c[4] = new int[] { 0, 8, 7, 6, 5, 4, 3, 2, 1 }; 
            c[5] = new int[] { 6, 5, 8, 3, 7, 1, 2, 4, 0 }; 
            c[6] = new int[] { 2, 0, 8, 7, 6, 3, 1, 4, 5 }; 
            c[7] = new int[] { 0, 7, 6, 3, 2, 1, 4, 5, 8 }; 
             
            
            string use = "";

            foreach (int[] a in c)
            {
                string s;
                Alg alg = new Alg(a, out s);
                s += "Initial State: ";
                foreach (int i in a)
                {
                    s += i;
                }
                s += System.Environment.NewLine;
                s += System.Environment.NewLine;
                use += s;
                outBox.Text = use;
                Thread.Sleep(300);
            }
        }

        private void butSolve_Click(object sender, EventArgs e)
        {
            string s;
            Alg a = new Alg(state, out s);
            s += "Initial State: ";
            foreach (int i in state)
            {
                s += i;
            }
            s += System.Environment.NewLine;
            outBox.Text = s;
            
        }

        private void DoSwap(int clicked, string label, int pos)
        {
            LinkLabel la = FindLabel(clicked);
            LinkLabel lb = FindLabel(pos);

            la.Text = "x";
            lb.Text = label;

            int i;
            int.TryParse(label, out i);

            state[clicked] = 0;
            state[pos] = i;
            foreach (int x in state)
            {
                Debug.Write(x);
            }
            Debug.WriteLine("");
        }

        private LinkLabel FindLabel(int i)
        {
            LinkLabel ret;
            switch (i)
            {
                case 0:
                    ret = position0;
                    break;
                case 1:
                    ret = position1;
                    break;
                case 2:
                    ret = position2;
                    break;
                case 3:
                    ret = position3;
                    break;
                case 4:
                    ret = position4;
                    break;
                case 5:
                    ret = position5;
                    break;
                case 6:
                    ret = position6;
                    break;
                case 7:
                    ret = position7;
                    break;
                case 8:
                    ret = position8;
                    break;
                default:
                    ret = position0;
                    break;
            }
            return ret;
        }

        private void TileShift(int clicked, string label)
        {
            if (!label.Equals("x"))
            {
                int pos = 0;

                for (int i = 0; i < 9; i++)
                {
                    if (state[i] == 0)
                    {
                        pos = i;
                    }
                }

                if (pos == 0)
                {
                    //0 is centered
                    if (clicked % 2 == 0)
                    {
                        DoSwap(clicked, label, pos);
                    }
                }
                else if (pos % 2 == 1)
                {
                    //0 is in an odd space
                    if (pos == 1)
                    {
                        if (clicked == 2 || clicked == 8)
                        {
                            DoSwap(clicked, label, pos);
                        }
                    }
                    else if (clicked == (pos + 1) || clicked == (pos - 1))
                    {
                        DoSwap(clicked, label, pos);
                    }
                }
                else
                {
                    //0 is in an even space
                    if (pos == 8)
                    {
                        if (clicked == 1 || clicked == 7 || clicked == 0)
                        {
                            DoSwap(clicked, label, pos);
                        }
                    }
                    else if (clicked == (pos + 1) || clicked == (pos - 1) || clicked == 0)
                    {
                        DoSwap(clicked, label, pos);
                    }
                }
            }
        }

        private void position1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(1, position1.Text);
        }

        private void position2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(2, position2.Text);
        }

        private void position3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(3, position3.Text);
        }

        private void position8_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(8, position8.Text);
        }

        private void position0_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(0, position0.Text);
        }

        private void position4_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(4, position4.Text);
        }

        private void position7_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(7, position7.Text);
        }

        private void position6_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(6, position6.Text);
        }

        private void position5_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            TileShift(5, position5.Text);
        }

        private void assBut_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(
                "This will cause the application to solve eight combinations in a row. On slower PCs this can take a long time",
                "Warning",              
                MessageBoxButtons.OKCancel) == DialogResult.OK)
            {
                AssSolve();
            }
        }
    }
}
